#include "testlib.h"
#include <iostream>
 
using namespace std;
 
const int MAXN[8] = {200'000, 20, 500, 200'000, 200'000, 200'000, 200'000, 200'000};
const int MAXM[8] = {200'000, 500, 250, 200'000, 1, 1, 200'000, 200'000};
const int MAXT[8] = {400'000, 1000, 500, 400'000, 400'000, 400'000, 400'000, 400'000};
const string SYMBOLS[8] = {"[a-z]", "[a-z]", "[a-z]", "[a-a]", "[a-b]", "[a-z]", "[a-b]", "[a-z]"};
const int MAXLEN = 200'000;
 
int main(int argc, char *argv[]) {
    registerGen(argc, argv, 1);
 
    int group = opt<int>("group");
    int n = opt<int>("n", MAXN[group]);
    int m = opt<int>("m", MAXM[group]);
    int T = opt<int>("T", MAXT[group]);
    cout << n << " " << m << "\n";
    string s = rnd.next(SYMBOLS[group] + "{" + to_string(n) + "-" + to_string(n) + "}");
    cout << s << "\n";
    vector<int> lens = rnd.partition(m, T, 2);
    for (int i = 0; i < m; i++) {
        lens[i] = min(lens[i], MAXLEN);
        string t = rnd.next(SYMBOLS[group] + "{" + to_string(lens[i]) + "-" + to_string(lens[i]) + "}");
        cout << t << "\n";
    }
    return 0;
}
