#include <bits/stdc++.h>

using namespace std;

using ll = long long;
const int inf = 1000000000 + 1;

int main() {
    ios::sync_with_stdio(false);
    cout.tie(nullptr);
    cin.tie(nullptr);
    int n, q; cin >> n >> q;
    string s; cin >> s;
    while (q--) {
        string t; cin >> t;
        int m = t.size();
        vector<vector<int>> dp(n, vector<int>(m, -inf));
        int ans = -1;
        for (int i = 0; i < n; i++) {
            if (t[0] == s[i]) {
                dp[i][0] = inf;
            }
            for (int j = 1; j < m; j++) {
                if (t[j] != s[i]) continue;
                for (int prv = 0; prv < i; prv++) {
                    dp[i][j] = max(dp[i][j], min(i - prv, dp[prv][j - 1]));
                }
            }
            ans = max(ans, dp[i][m - 1]);
        }
        cout << ans << '\n';
    }
}
