#include "testlib.h"
using namespace std;

typedef long long ll;

/*
0 группа - сэмплы
1 группа - n <= 20, T <= 1000
2 группа - n <= 500, T <= 500
3 группа - все символы a
4 группа - m = 1, все символы a-b
5 группа - m = 1
6 группа - все символы a-b
7 группа - фулл
*/

const int MAXN[8] = {200'000, 20, 500, 200'000, 200'000, 200'000, 200'000, 200'000};
const int MAXM[8] = {200'000, 500, 250, 200'000, 1, 1, 200'000, 200'000};
const int MAXT[8] = {400'000, 1000, 500, 400'000, 400'000, 400'000, 400'000, 400'000};
const string SYMBOLS[8] = {"[a-z]", "[a-z]", "[a-z]", "[a-a]", "[a-b]", "[a-z]", "[a-b]", "[a-z]"};
const int MAXLEN = 200'000;

int main(int argc, char *argv[]){
    registerValidation(argc, argv);
    int group = validator.group().empty() ? 0 : atoi(validator.group().c_str());
    ensuref(group >= 0 && group <= 7, "incorrect group");
    int n = inf.readInt(1, MAXN[group], "n");
    inf.readSpace();
    int m = inf.readInt(1, MAXM[group], "m");
    inf.readEoln();
    string s = inf.readString(SYMBOLS[group] + "{" + to_string(n) + "-" + to_string(n) + "}", "s");
    int T = 0;
    for (int i = 0; i < m; i++) {
        string t = inf.readString(SYMBOLS[group] + "{2," + to_string(MAXLEN) + "}", "t");
        T += int(t.size());
        ensuref(T <= MAXT[group], "incorrect sum sizes t");
    }
    inf.readEof();
}
