#pragma GCC optimize("Ofast,O3,unroll-loops,fast-math")

#ifdef LOCAL
#define _GLIBCXX_DEBUG
#endif
//#include <bits/stdc++.h>
//#include <ext/pb_ds/assoc_container.hpp>
//#include <ext/pb_ds/tree_policy.hpp>

#include <iostream>
#include <utility>
#include <vector>
#include <algorithm>
#define _USE_MATH_DEFINES
#include <cmath>
#include <map>
#include <set>
#include <queue>
#include <stack>
#include <deque>
#include <fstream>
#include <random>
#include <cassert>
#include <bitset>
#include <unordered_map>
#include <unordered_set>
#include <list>
#include <sstream>

using namespace std;
//using namespace __gnu_pbds;

using ll = long long;
using ull = unsigned long long;
using ld = long double;
using pll = pair<ll, ll>;
using vll = vector<ll>;
using vpll = vector<pair<ll, ll>>;
using vii = vector<int>;

//#define fill(a) for (ll i = 0; i < (a).size(); i++) cin >> (a)[i]
#define mp make_pair
#define mt make_tuple
#define bs(a, b) binary_search((a).begin(), (a).end(), (b))
//#define ordered_set(a) tree<a, null_type , less<>, rb_tree_tag, tree_order_statistics_node_update>

random_device rd;
mt19937 gen(0);

const ld EPS = 1e-9;
const ld phi = (1 + sqrt(5)) / 2;

const ll MOD = 1e9 + 7;
const ll INF = 1e18;
const ll P = 239;
const ll B = 350;
const ll lg = 17;

int main() {
#ifdef LOCAL
    freopen("inp.txt", "r", stdin);
    freopen("out.txt", "w", stdout);
//    freopen("err.txt", "w", stderr);

    clock_t timer = clock();
#else
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.precision(64);
    cout << fixed;
#endif

    ll n, q;
    cin >> n >> q;

    string s;
    cin >> s;

    vector<vector<int>> go(n, vector<int>(26, -1));

    vector<ll> last(26, 0);

    for (ll i = 0; i < n; i++) {
        for (ll j = last[s[i] - 'a']; j < i; j++) {
            go[j][s[i] - 'a'] = i;
        }

        last[s[i] - 'a'] = i;
    }

    cout << "";

    while (q--) {
        string t;
        cin >> t;

        ll start = s.find(t[0]);
        if (start == string::npos) {
            cout << "-1\n";
            continue;
        }

        ll L = 0, R = n + 1;
        while (R - L > 1) {
            ll m = L + (R - L) / 2;

            ll ind = start;

            bool ok = true;

            for (ll i = 1; i < t.size(); i++) {
                if (ind + m - 1 >= s.size() || go[ind + m - 1][t[i] - 'a'] == -1) {
                    ok = false;
                    break;
                }

                ind = go[ind + m - 1][t[i] - 'a'];
            }

            if (ok)
                L = m;
            else
                R = m;
        }

        cout << (L != 0 ? L : -1) << "\n";
    }

#ifdef LOCAL
    cout << endl << "Execution time: " << (ld)(clock() - timer) / CLOCKS_PER_SEC;
#endif
}
